Attribute VB_Name = "modS309PyramidSolitaire"
' S309 Pyramid Solitaire
' Written by Terry Myhrer, Software 309
Option Explicit

Dim picCards(30) As S309PictureBox
Dim lblCount(2) As Label
Dim gnShuffledDeck(52), gnCards(30), gnLeft(7), gnPile(2, 52), gnCardCovered(30, 2), gnStack(100, 1)
Dim gnCardHeight, gnCardWidth, gnWidth(1), gnHeight, gnPileIndex(2), gnSelected(1), gnStackIndex
Dim gstrTitle, gstrURL
Dim gnOutputWidth, gnOutputHeight

Sub Initialize()
    Dim nIndex1, nIndex2, nIndex3, nLabelTop, nLabelLeft, nLabelWidth, nLabelHeight
  
    Set picCards(0) = frmS309PyramidSolitaire.S309PictureBox0
    Set picCards(1) = frmS309PyramidSolitaire.S309PictureBox1
    Set picCards(2) = frmS309PyramidSolitaire.S309PictureBox2
    Set picCards(3) = frmS309PyramidSolitaire.S309PictureBox3
    Set picCards(4) = frmS309PyramidSolitaire.S309PictureBox4
    Set picCards(5) = frmS309PyramidSolitaire.S309PictureBox5
    Set picCards(6) = frmS309PyramidSolitaire.S309PictureBox6
    Set picCards(7) = frmS309PyramidSolitaire.S309PictureBox7
    Set picCards(8) = frmS309PyramidSolitaire.S309PictureBox8
    Set picCards(9) = frmS309PyramidSolitaire.S309PictureBox9
    Set picCards(10) = frmS309PyramidSolitaire.S309PictureBox10
    Set picCards(11) = frmS309PyramidSolitaire.S309PictureBox11
    Set picCards(12) = frmS309PyramidSolitaire.S309PictureBox12
    Set picCards(13) = frmS309PyramidSolitaire.S309PictureBox13
    Set picCards(14) = frmS309PyramidSolitaire.S309PictureBox14
    Set picCards(15) = frmS309PyramidSolitaire.S309PictureBox15
    Set picCards(16) = frmS309PyramidSolitaire.S309PictureBox16
    Set picCards(17) = frmS309PyramidSolitaire.S309PictureBox17
    Set picCards(18) = frmS309PyramidSolitaire.S309PictureBox18
    Set picCards(19) = frmS309PyramidSolitaire.S309PictureBox19
    Set picCards(20) = frmS309PyramidSolitaire.S309PictureBox20
    Set picCards(21) = frmS309PyramidSolitaire.S309PictureBox21
    Set picCards(22) = frmS309PyramidSolitaire.S309PictureBox22
    Set picCards(23) = frmS309PyramidSolitaire.S309PictureBox23
    Set picCards(24) = frmS309PyramidSolitaire.S309PictureBox24
    Set picCards(25) = frmS309PyramidSolitaire.S309PictureBox25
    Set picCards(26) = frmS309PyramidSolitaire.S309PictureBox26
    Set picCards(27) = frmS309PyramidSolitaire.S309PictureBox27
    Set picCards(28) = frmS309PyramidSolitaire.S309PictureBox28
    Set picCards(29) = frmS309PyramidSolitaire.S309PictureBox29
    Set picCards(30) = frmS309PyramidSolitaire.S309PictureBox30
  
    frmS309PyramidSolitaire.ScaleMode = vbPixels
    frmS309PyramidSolitaire.Height = picCards(0).ScreenHeight * Screen.TwipsPerPixelY
    frmS309PyramidSolitaire.Width = picCards(0).ScreenWidth * Screen.TwipsPerPixelX
        
    picCards(0).PlayingCard = 1
    gnCardHeight = picCards(0).ImageHeight
    gnCardWidth = picCards(0).ImageWidth
    gnHeight = gnCardHeight * 3
    gnWidth(0) = ((gnCardWidth + 2) * 6) + 2
    gnWidth(1) = ((gnCardWidth + 2) * 7) + 2
    
    gnOutputHeight = (picCards(0).ScreenHeight - (picCards(0).ScreenTop - picCards(0).Top))
    gnOutputWidth = (picCards(0).ScreenWidth - (picCards(0).ScreenLeft - picCards(0).Left))
    
    gstrTitle = "S309 Pyramid Solitaire"
    gstrURL = "http://members.xoom.com/S309"
    
    If gnOutputWidth > 240 Then
        frmS309PyramidSolitaire.mnuTitleSub1.Caption = gstrTitle
        frmS309PyramidSolitaire.mnuTitleSub2.Caption = gstrURL
    Else
        frmS309PyramidSolitaire.mnuTitleSub1.Caption = gstrURL
        frmS309PyramidSolitaire.mnuTitleSub2.Visible = False
    End If
    
    Randomize
  
    nIndex3 = 0
    For nIndex1 = 1 To 6
      For nIndex2 = 1 To nIndex1
        gnCardCovered((nIndex3 + nIndex2), 0) = nIndex3 + nIndex1 + nIndex2
        gnCardCovered((nIndex3 + nIndex2), 1) = nIndex3 + nIndex1 + nIndex2 + 1
      Next
      nIndex3 = nIndex3 + nIndex1
    Next
    
    LoadDeck
    
    gnLeft(1) = 3
    gnLeft(2) = 2
    gnLeft(3) = 2
    gnLeft(4) = 1
    gnLeft(5) = 1
    gnLeft(6) = 0
    gnLeft(7) = 0
    
    MakeCard 0, 0, 1
    
    Set lblCount(0) = frmS309PyramidSolitaire.Label0
    lblCount(0).Left = nCardLeft(1, 0)
    lblCount(0).Alignment = 2
    
    Set lblCount(1) = frmS309PyramidSolitaire.Label1
    lblCount(1).Left = nCardLeft(6, 0)
    lblCount(1).Alignment = 1
    
    Set lblCount(2) = frmS309PyramidSolitaire.Label2
    lblCount(2).Left = nCardLeft(7, 0)
    lblCount(2).Alignment = 2
    
    nLabelHeight = nCardTop(5) - (picCards(0).Top + gnCardHeight)
    For nIndex1 = 0 To 2
      lblCount(nIndex1).Top = picCards(0).Top + gnCardHeight
      lblCount(nIndex1).Width = gnCardWidth
      lblCount(nIndex1).Height = nLabelHeight
      lblCount(nIndex1).FontBold = True
      lblCount(nIndex1).Caption = ""
      lblCount(nIndex1).ZOrder 1
    Next
    
    nIndex3 = 1
    For nIndex1 = 1 To 7
      For nIndex2 = 1 To nIndex1
        MakeCard nIndex3, nIndex1, gnLeft(nIndex1) + nIndex2
        nIndex3 = nIndex3 + 1
      Next
    Next
    
    MakeCard 29, 0, 6
    MakeCard 30, 0, 7
    
    mnuGameNew_Click
  
End Sub

Sub mnuHelpRules_Click()
  frmS309PyramidSolitaire.dlgHelp.HelpFile = gstrTitle & ".htc"
  frmS309PyramidSolitaire.dlgHelp.ShowHelp
End Sub

Sub mnuHelpAbout_Click()
  Dim strText
  strText = gstrTitle & " 1.2" & vbCrLf
  strText = strText & "Written by Terry Myhrer, Software 309" & vbCrLf
  strText = strText & "Email: software309@pobox.com" & vbCrLf
  strText = strText & "Web: " & gstrURL
  MsgBox strText, vbInformation, "About " & gstrTitle
End Sub

Sub mnuGameNew_Click()
  Dim nIndex1, nIndex2
  
  If gnPileIndex(2) > 1 Then
    Exit Sub
  End If
    
  ShuffleDeck
  
  For nIndex1 = 1 To 28
    gnCards(nIndex1) = gnShuffledDeck(nIndex1)
    Call DisplayCard(nIndex1)
  Next
  nIndex2 = 24
  For nIndex1 = 29 To 52
    gnPile(2, nIndex2) = gnShuffledDeck(nIndex1)
    nIndex2 = nIndex2 - 1
  Next
  gnPileIndex(0) = 0
  gnPileIndex(1) = 0
  gnPileIndex(2) = 24
  gnSelected(0) = 0
  gnSelected(1) = 0
  gnStackIndex = 0
    
  DisplayPile 0
  DisplayPile 1
  DisplayPile 2
End Sub

Sub mnuFileExit_Click()
  App.End
End Sub

Sub mnuGameUndo_Click()
  Dim nIndex1, nTemp, nPile
  
  If gnStackIndex < 1 Then
    Exit Sub
  End If
  For nIndex1 = 0 To 1
    If gnSelected(nIndex1) > 0 Then
      DisplayCard gnSelected(nIndex1)
      gnSelected(nIndex1) = 0
    End If
  Next
  For nIndex1 = 1 To 0 Step -1
    nTemp = gnStack(gnStackIndex, nIndex1)
    If nTemp = -1 Then
      gnPileIndex(2) = gnPileIndex(2) + 1
      gnPile(2, gnPileIndex(2)) = gnPile(1, gnPileIndex(1))
      gnPileIndex(1) = gnPileIndex(1) - 1
      DisplayPile 1
      DisplayPile 2
    ElseIf nTemp > 52 Then
      nPile = 0
      While nTemp > 52
        nTemp = nTemp - 52
        nPile = nPile + 1
      Wend
      gnPileIndex(nPile) = gnPileIndex(nPile) + 1
      gnPile(nPile, gnPileIndex(nPile)) = gnPile(0, gnPileIndex(0))
      gnPileIndex(0) = gnPileIndex(0) - 1
      DisplayPile nPile
      DisplayPile 0
    ElseIf nTemp > 0 Then
      gnPileIndex(0) = gnPileIndex(0) - 1
      DisplayCard nTemp
      DisplayPile 0
    End If
  Next
  gnStackIndex = gnStackIndex - 1
End Sub
Function bCardIsCovered(ByVal nNumber)
  Dim nIndex1

  If gnCardCovered(nNumber, 0) = 0 Then
    Exit Function
  End If
    
  For nIndex1 = 0 To 1
    If picCards(gnCardCovered(nNumber, nIndex1)).Visible Then
      bCardIsCovered = True
      Exit For
    End If
  Next
End Function
Function nCardValue(ByVal nNumber)
  nCardValue = ((nNumber - 1) Mod 13) + 1
End Function
Sub CardClick(ByVal nNumber)
  Dim nIndex1, bFound, nCount, bNextStack
  
  If bCardIsCovered(nNumber) Then
    Exit Sub
  End If
    
  For nIndex1 = 0 To 1
    If gnSelected(nIndex1) = nNumber Then
      gnSelected(nIndex1) = 0
      picCards(nNumber).InvertImage
      bFound = True
      Exit For
    End If
  Next
  If Not bFound Then
    For nIndex1 = 0 To 1
      If gnSelected(nIndex1) = 0 Then
        gnSelected(nIndex1) = nNumber
        picCards(nNumber).InvertImage
        bFound = True
        Exit For
      End If
    Next
  End If
    
  nCount = 0
  For nIndex1 = 0 To 1
    If gnSelected(nIndex1) <> 0 Then
      nCount = nCount + nCardValue(gnCards(gnSelected(nIndex1)))
    End If
  Next
  If nCount = 13 Then
    For nIndex1 = 0 To 1
      If gnSelected(nIndex1) <> 0 Then
        If Not bNextStack Then
          gnStackIndex = gnStackIndex + 1
          gnStack(gnStackIndex, 0) = 0
          gnStack(gnStackIndex, 1) = 0
          bNextStack = True
        End If
        gnPileIndex(0) = gnPileIndex(0) + 1
        gnPile(0, gnPileIndex(0)) = gnCards(gnSelected(nIndex1))
        If gnSelected(nIndex1) > 28 Then
          gnStack(gnStackIndex, nIndex1) = ((gnSelected(nIndex1) - 28) * 52) + gnCards(gnSelected(nIndex1))
          gnPileIndex(gnSelected(nIndex1) - 28) = gnPileIndex(gnSelected(nIndex1) - 28) - 1
          DisplayPile gnSelected(nIndex1) - 28
        Else
          gnStack(gnStackIndex, nIndex1) = gnSelected(nIndex1)
          picCards(gnSelected(nIndex1)).Visible = False
        End If
        gnSelected(nIndex1) = 0
        DisplayPile 0
      End If
    Next
  End If
End Sub
Sub CardDblClick(ByVal nNumber)
  Dim nIndex1
  If (nNumber = 30) And (gnPileIndex(2) > 1) Then
    gnPileIndex(1) = gnPileIndex(1) + 1
    gnPile(1, gnPileIndex(1)) = gnPile(2, gnPileIndex(2))
    gnPileIndex(2) = gnPileIndex(2) - 1
    DisplayPile 1
    DisplayPile 2

    For nIndex1 = 0 To 1
      If gnSelected(nIndex1) > 28 Then
        gnSelected(nIndex1) = 0
        Exit For
      End If
    Next
  End If
  gnStackIndex = gnStackIndex + 1
  gnStack(gnStackIndex, 0) = -1
  gnStack(gnStackIndex, 1) = 0
End Sub
      
Sub ShuffleDeck()
   Dim nTemp1, nTemp2, nTemp3

   For nTemp1 = 52 To 2 Step -1

      nTemp2 = nTemp1
      While (nTemp1 = nTemp2)
         nTemp2 = Int(Rnd * nTemp1) + 1
      Wend

      nTemp3 = gnShuffledDeck(nTemp1)
      gnShuffledDeck(nTemp1) = gnShuffledDeck(nTemp2)
      gnShuffledDeck(nTemp2) = nTemp3

   Next
End Sub
Sub DisplayPile(ByVal nNumber)
  If nNumber = 0 Then
    gnCards(0) = gnPile(0, gnPileIndex(0))
    DisplayCard 0
  Else
    gnCards(nNumber + 28) = gnPile(nNumber, gnPileIndex(nNumber))
    DisplayCard nNumber + 28
  End If
  lblCount(nNumber).Caption = gnPileIndex(nNumber)
End Sub
Sub DisplayCard(ByVal nNumber)
  Dim nIndex, bInvert, picCard
  
  Set picCard = picCards(nNumber)
  nIndex = gnCards(nNumber)
  If nIndex = 0 Then
    picCard.BorderStyle = 1
    picCard.Appearance = -1
    picCard.Cls
  Else
    picCard.BorderStyle = 0
    picCard.Appearance = 0
    picCard.PlayingCard = nIndex
  End If
  picCard.Visible = True
  picCard.Refresh
End Sub
Sub LoadDeck()
  Dim nIndex
  
  For nIndex = 1 To 52
    gnShuffledDeck(nIndex) = nIndex
  Next
End Sub
Sub MakeCard(ByVal nNumber, ByVal nRow, ByVal nColumn)
    Dim picCard As S309PictureBox
    
    Set picCard = picCards(nNumber)
    
    picCard.Visible = False
    
    picCard.Left = nCardLeft(nColumn, nRow)
    picCard.Top = nCardTop(nRow)
    picCard.Width = gnCardWidth - 6 ' because vbce can't count right
    picCard.Height = gnCardHeight - 6 ' because vbce can't count right
    picCard.BackColor = frmS309PyramidSolitaire.BackColor
    
    gnCards(nNumber) = 0
End Sub
Function nCardTop(ByVal nRow)
  Dim nOffset
  nOffset = (gnOutputHeight - gnHeight) \ 2
  nCardTop = ((gnHeight - gnCardHeight) \ 7) * nRow + nOffset
End Function
Function nCardLeft(ByVal nColumn, ByVal nRow)
  Dim nOffset, nTemp
  If (nRow = 0) Or ((nRow Mod 2) = 1) Then
    nOffset = (gnOutputWidth - gnWidth(1)) \ 2
    nTemp = (((gnWidth(1) - (gnCardWidth * 7)) \ 8) * nColumn) + (gnCardWidth * (nColumn - 1))
  Else
    nOffset = (gnOutputWidth - gnWidth(0)) / 2
    nTemp = (((gnWidth(0) - (gnCardWidth * 6)) \ 7) * nColumn) + (gnCardWidth * (nColumn - 1))
  End If
  nCardLeft = nTemp + nOffset
End Function
Private Sub S309PictureBox0_Click()
    Call CardClick(0)
End Sub
Private Sub S309PictureBox1_Click()
    Call CardClick(1)
End Sub
Private Sub S309PictureBox2_Click()
    Call CardClick(2)
End Sub
Private Sub S309PictureBox3_Click()
    Call CardClick(3)
End Sub


Private Sub S309PictureBox4_Click()
    Call CardClick(4)
End Sub
Private Sub S309PictureBox5_Click()
    Call CardClick(5)
End Sub
Private Sub S309PictureBox6_Click()
    Call CardClick(6)
End Sub
Private Sub S309PictureBox7_Click()
    Call CardClick(7)
End Sub
Private Sub S309PictureBox8_Click()
    Call CardClick(8)
End Sub
Private Sub S309PictureBox9_Click()
    Call CardClick(9)
End Sub
Private Sub S309PictureBox10_Click()
    Call CardClick(10)
End Sub
Private Sub S309PictureBox11_Click()
    Call CardClick(11)
End Sub
Private Sub S309PictureBox12_Click()
    Call CardClick(12)
End Sub
Private Sub S309PictureBox13_Click()
    Call CardClick(13)
End Sub
Private Sub S309PictureBox14_Click()
    Call CardClick(14)
End Sub
Private Sub S309PictureBox15_Click()
    Call CardClick(15)
End Sub
Private Sub S309PictureBox16_Click()
    Call CardClick(16)
End Sub
Private Sub S309PictureBox17_Click()
    Call CardClick(17)
End Sub
Private Sub S309PictureBox18_Click()
    Call CardClick(18)
End Sub
Private Sub S309PictureBox19_Click()
    Call CardClick(19)
End Sub
Private Sub S309PictureBox20_Click()
    Call CardClick(20)
End Sub
Private Sub S309PictureBox21_Click()
    Call CardClick(21)
End Sub
Private Sub S309PictureBox22_Click()
    Call CardClick(22)
End Sub
Private Sub S309PictureBox23_Click()
    Call CardClick(23)
End Sub
Private Sub S309PictureBox24_Click()
    Call CardClick(24)
End Sub
Private Sub S309PictureBox25_Click()
    Call CardClick(25)
End Sub
Private Sub S309PictureBox26_Click()
    Call CardClick(26)
End Sub
Private Sub S309PictureBox27_Click()
    Call CardClick(27)
End Sub
Private Sub S309PictureBox28_Click()
    Call CardClick(28)
End Sub
Private Sub S309PictureBox29_Click()
    Call CardClick(29)
End Sub
Private Sub S309PictureBox30_Click()
    Call CardClick(30)
End Sub
Private Sub S309PictureBox30_DblClick()
    Call CardDblClick(30)
End Sub


